diff --git a/lightningd/chaintopology.c b/lightningd/chaintopology.c
index 1907c596d41..864b005a1b8 100644
--- a/lightningd/chaintopology.c
+++ b/lightningd/chaintopology.c
@@ -522,22 +522,22 @@ static void get_init_blockhash(struct bitcoind *bitcoind, u32 blockcount,
 	 * go back to that height. This might be a new node catching up, or
 	 * bitcoind is processing a reorg. */
 	if (blockcount < topo->max_blockheight) {
-		if (bitcoind->ld->config.rescan < 0) {
-			/* Absolute blockheight, but bitcoind's blockheight isn't there yet */
+		if (topo->max_blockheight == UINT32_MAX) {
+			/* Relative rescan, but we didn't know the blockheight */
 			/* Protect against underflow in subtraction.
 			 * Possible in regtest mode. */
-			if (blockcount < 1)
+			if (blockcount < bitcoind->ld->config.rescan)
 				topo->max_blockheight = 0;
 			else
-				topo->max_blockheight = blockcount - 1;
-		} else if (topo->max_blockheight == UINT32_MAX) {
-			/* Relative rescan, but we didn't know the blockheight */
+				topo->max_blockheight = blockcount - bitcoind->ld->config.rescan;
+		} else {
+			/* Absolute blockheight, but bitcoind's blockheight isn't there yet */
 			/* Protect against underflow in subtraction.
 			 * Possible in regtest mode. */
-			if (blockcount < bitcoind->ld->config.rescan)
+			if (blockcount < 1)
 				topo->max_blockheight = 0;
 			else
-				topo->max_blockheight = blockcount - bitcoind->ld->config.rescan;
+				topo->max_blockheight = blockcount - 1;
 		}
 	}
 
